From patchwork Mon Nov 14 12:51:42 2022
Content-Type: text/plain; charset="utf-8"
MIME-Version: 1.0
Content-Transfer-Encoding: 7bit
X-Patchwork-Submitter: Jason Yan <yanaijie@huawei.com>
X-Patchwork-Id: 183290
Return-Path: <yanaijie@huawei.com>
Received: from dggems703-chm.china.huawei.com (10.3.19.180) by
 dggems702-chm.china.huawei.com (10.3.19.179) with Microsoft SMTP Server
 (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256) id
 15.1.2375.31 via Mailbox Transport; Mon, 14 Nov 2022 20:33:44 +0800
Received: from canpemm500004.china.huawei.com (7.192.104.92) by
 dggems703-chm.china.huawei.com (10.3.19.180) with Microsoft SMTP Server
 (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256) id
 15.1.2375.31; Mon, 14 Nov 2022 20:33:44 +0800
Received: from huawei.com (10.175.127.227) by canpemm500004.china.huawei.com
 (7.192.104.92) with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256) id 15.1.2375.31; Mon, 14 Nov
 2022 20:33:43 +0800
From: Jason Yan <yanaijie@huawei.com>
To: <yanaijie@huawei.com>, <zhengzengkai@huawei.com>, <xiexiuqi@huawei.com>,
	<yi.zhang@huawei.com>, <patchwork@huawei.com>, <kernel.openeuler@huawei.com>,
	<houtao1@huawei.com>
Subject: [PATCH OLK-5.10 v2 193/308] ksmbd: fix missing error code in
 smb2_lock
Date: Mon, 14 Nov 2022 20:51:42 +0800
Message-ID: <20221114125337.1831594-194-yanaijie@huawei.com>
X-Mailer: git-send-email 2.31.1
In-Reply-To: <20221114125337.1831594-1-yanaijie@huawei.com>
References: <20221114125337.1831594-1-yanaijie@huawei.com>
Content-Type: text/plain
X-MS-Exchange-Organization-Network-Message-Id: 
 2208543c-0b4e-4ddd-4718-08dac63c7822
X-MS-Exchange-Organization-AuthSource: canpemm500004.china.huawei.com
X-MS-Exchange-Organization-AuthAs: Internal
X-MS-Exchange-Organization-AuthMechanism: 07
X-Originating-IP: [10.175.127.227]
X-ClientProxiedBy: dggems702-chm.china.huawei.com (10.3.19.179) To
 canpemm500004.china.huawei.com (7.192.104.92)
X-MS-Exchange-Transport-EndToEndLatency: 00:00:00.6772324
X-MS-Exchange-Processed-By-BccFoldering: 15.01.2375.031
MIME-Version: 1.0

From: Namjae Jeon <namjae.jeon@samsung.com>

mainline inclusion
from mainline-5.15-rc1
commit 6c99dfc4c5f6fa1f5a90c068be6201d7a0cebff1
category: feature
bugzilla: https://gitee.com/openeuler/kernel/issues/I60T7G
CVE: NA

Reference: https://git.kernel.org/torvalds/linux/c/6c99dfc4c5f6

-------------------------------

Dan report a warning that is missing error code in smb2_lock
from static checker. This patch add error code to avoid static checker
warning.

Reported-by: Dan Carpenter <dan.carpenter@oracle.com>
Signed-off-by: Namjae Jeon <namjae.jeon@samsung.com>
Signed-off-by: Steve French <stfrench@microsoft.com>
Signed-off-by: Jason Yan <yanaijie@huawei.com>
---
 fs/ksmbd/smb2pdu.c | 66 ++++++++++++++++++++++++----------------------
 1 file changed, 34 insertions(+), 32 deletions(-)

diff --git a/fs/ksmbd/smb2pdu.c b/fs/ksmbd/smb2pdu.c
index 4b3df48df7a4..32a66f37e008 100644
--- a/fs/ksmbd/smb2pdu.c
+++ b/fs/ksmbd/smb2pdu.c
@@ -6544,7 +6544,7 @@ int smb2_lock(struct ksmbd_work *work)
 	int lock_count;
 	int flags = 0;
 	int cmd = 0;
-	int err = 0, i;
+	int err = -EIO, i, rc = 0;
 	u64 lock_start, lock_length;
 	struct ksmbd_lock *smb_lock = NULL, *cmp_lock, *tmp, *tmp2;
 	struct ksmbd_conn *conn;
@@ -6560,7 +6560,7 @@ int smb2_lock(struct ksmbd_work *work)
 	if (!fp) {
 		ksmbd_debug(SMB, "Invalid file id for lock : %llu\n",
 			    le64_to_cpu(req->VolatileFileId));
-		rsp->hdr.Status = STATUS_FILE_CLOSED;
+		err = -ENOENT;
 		goto out2;
 	}
 
@@ -6570,7 +6570,7 @@ int smb2_lock(struct ksmbd_work *work)
 
 	ksmbd_debug(SMB, "lock count is %d\n", lock_count);
 	if (!lock_count) {
-		rsp->hdr.Status = STATUS_INVALID_PARAMETER;
+		err = -EINVAL;
 		goto out2;
 	}
 
@@ -6578,10 +6578,8 @@ int smb2_lock(struct ksmbd_work *work)
 		flags = le32_to_cpu(lock_ele[i].Flags);
 
 		flock = smb_flock_init(filp);
-		if (!flock) {
-			rsp->hdr.Status = STATUS_LOCK_NOT_GRANTED;
+		if (!flock)
 			goto out;
-		}
 
 		cmd = smb2_set_flock_flags(flock, flags);
 
@@ -6619,8 +6617,7 @@ int smb2_lock(struct ksmbd_work *work)
 				if (cmp_lock->fl->fl_type != F_UNLCK &&
 				    flock->fl_type != F_UNLCK) {
 					pr_err("conflict two locks in one request\n");
-					rsp->hdr.Status =
-						STATUS_INVALID_PARAMETER;
+					err = -EINVAL;
 					goto out;
 				}
 			}
@@ -6628,19 +6625,19 @@ int smb2_lock(struct ksmbd_work *work)
 
 		smb_lock = smb2_lock_init(flock, cmd, flags, &lock_list);
 		if (!smb_lock) {
-			rsp->hdr.Status = STATUS_INVALID_PARAMETER;
+			err = -EINVAL;
 			goto out;
 		}
 	}
 
 	list_for_each_entry_safe(smb_lock, tmp, &lock_list, llist) {
 		if (smb_lock->cmd < 0) {
-			rsp->hdr.Status = STATUS_INVALID_PARAMETER;
+			err = -EINVAL;
 			goto out;
 		}
 
 		if (!(smb_lock->flags & SMB2_LOCKFLAG_MASK)) {
-			rsp->hdr.Status = STATUS_INVALID_PARAMETER;
+			err = -EINVAL;
 			goto out;
 		}
 
@@ -6648,7 +6645,7 @@ int smb2_lock(struct ksmbd_work *work)
 		     smb_lock->flags & SMB2_LOCKFLAG_UNLOCK) ||
 		    (prior_lock == SMB2_LOCKFLAG_UNLOCK &&
 		     !(smb_lock->flags & SMB2_LOCKFLAG_UNLOCK))) {
-			rsp->hdr.Status = STATUS_INVALID_PARAMETER;
+			err = -EINVAL;
 			goto out;
 		}
 
@@ -6701,8 +6698,7 @@ int smb2_lock(struct ksmbd_work *work)
 					spin_unlock(&conn->llist_lock);
 					read_unlock(&conn_list_lock);
 					pr_err("previous lock conflict with zero byte lock range\n");
-					rsp->hdr.Status = STATUS_LOCK_NOT_GRANTED;
-						goto out;
+					goto out;
 				}
 
 				if (smb_lock->zero_len && !cmp_lock->zero_len &&
@@ -6711,8 +6707,7 @@ int smb2_lock(struct ksmbd_work *work)
 					spin_unlock(&conn->llist_lock);
 					read_unlock(&conn_list_lock);
 					pr_err("current lock conflict with zero byte lock range\n");
-					rsp->hdr.Status = STATUS_LOCK_NOT_GRANTED;
-						goto out;
+					goto out;
 				}
 
 				if (((cmp_lock->start <= smb_lock->start &&
@@ -6723,8 +6718,6 @@ int smb2_lock(struct ksmbd_work *work)
 					spin_unlock(&conn->llist_lock);
 					read_unlock(&conn_list_lock);
 					pr_err("Not allow lock operation on exclusive lock range\n");
-					rsp->hdr.Status =
-						STATUS_LOCK_NOT_GRANTED;
 					goto out;
 				}
 			}
@@ -6747,19 +6740,19 @@ int smb2_lock(struct ksmbd_work *work)
 		flock = smb_lock->fl;
 		list_del(&smb_lock->llist);
 retry:
-		err = vfs_lock_file(filp, smb_lock->cmd, flock, NULL);
+		rc = vfs_lock_file(filp, smb_lock->cmd, flock, NULL);
 skip:
 		if (flags & SMB2_LOCKFLAG_UNLOCK) {
-			if (!err) {
+			if (!rc) {
 				ksmbd_debug(SMB, "File unlocked\n");
-			} else if (err == -ENOENT) {
+			} else if (rc == -ENOENT) {
 				rsp->hdr.Status = STATUS_NOT_LOCKED;
 				goto out;
 			}
 			locks_free_lock(flock);
 			kfree(smb_lock);
 		} else {
-			if (err == FILE_LOCK_DEFERRED) {
+			if (rc == FILE_LOCK_DEFERRED) {
 				void **argv;
 
 				ksmbd_debug(SMB,
@@ -6777,12 +6770,11 @@ int smb2_lock(struct ksmbd_work *work)
 				}
 				argv[0] = flock;
 
-				err = setup_async_work(work,
-						       smb2_remove_blocked_lock,
-						       argv);
-				if (err) {
-					rsp->hdr.Status =
-					   STATUS_INSUFFICIENT_RESOURCES;
+				rc = setup_async_work(work,
+						      smb2_remove_blocked_lock,
+						      argv);
+				if (rc) {
+					err = -ENOMEM;
 					goto out;
 				}
 				spin_lock(&fp->f_lock);
@@ -6829,7 +6821,7 @@ int smb2_lock(struct ksmbd_work *work)
 				list_del(&work->fp_entry);
 				spin_unlock(&fp->f_lock);
 				goto retry;
-			} else if (!err) {
+			} else if (!rc) {
 				spin_lock(&work->conn->llist_lock);
 				list_add_tail(&smb_lock->clist,
 					      &work->conn->lock_list);
@@ -6839,7 +6831,6 @@ int smb2_lock(struct ksmbd_work *work)
 				list_add(&smb_lock->llist, &rollback_list);
 				ksmbd_debug(SMB, "successful in taking lock\n");
 			} else {
-				rsp->hdr.Status = STATUS_LOCK_NOT_GRANTED;
 				goto out;
 			}
 		}
@@ -6865,7 +6856,6 @@ int smb2_lock(struct ksmbd_work *work)
 
 	list_for_each_entry_safe(smb_lock, tmp, &rollback_list, llist) {
 		struct file_lock *rlock = NULL;
-		int rc;
 
 		rlock = smb_flock_init(filp);
 		rlock->fl_type = F_UNLCK;
@@ -6888,7 +6878,19 @@ int smb2_lock(struct ksmbd_work *work)
 		kfree(smb_lock);
 	}
 out2:
-	ksmbd_debug(SMB, "failed in taking lock(flags : %x)\n", flags);
+	ksmbd_debug(SMB, "failed in taking lock(flags : %x), err : %d\n", flags, err);
+
+	if (!rsp->hdr.Status) {
+		if (err == -EINVAL)
+			rsp->hdr.Status = STATUS_INVALID_PARAMETER;
+		else if (err == -ENOMEM)
+			rsp->hdr.Status = STATUS_INSUFFICIENT_RESOURCES;
+		else if (err == -ENOENT)
+			rsp->hdr.Status = STATUS_FILE_CLOSED;
+		else
+			rsp->hdr.Status = STATUS_LOCK_NOT_GRANTED;
+	}
+
 	smb2_set_err_rsp(work);
 	ksmbd_fd_put(work, fp);
 	return err;

